package cuda

/*
 THIS FILE IS AUTO-GENERATED BY CUDA2GO.
 EDITING IS FUTILE.
*/

import (
	"github.com/mumax/3/cuda/cu"
	"github.com/mumax/3/timer"
	"sync"
	"unsafe"
)

// CUDA handle for solidanglefourierfield kernel
var solidanglefourierfield_code cu.Function

// Stores the arguments for solidanglefourierfield kernel invocation
type solidanglefourierfield_args_t struct {
	arg_fftFx_partial unsafe.Pointer
	arg_fftFy_partial unsafe.Pointer
	arg_fftFz_partial unsafe.Pointer
	arg_fftFx         unsafe.Pointer
	arg_fftFy         unsafe.Pointer
	arg_fftFz         unsafe.Pointer
	arg_Nx            int
	arg_Ny            int
	arg_Nz            int
	argptr            [9]unsafe.Pointer
	sync.Mutex
}

// Stores the arguments for solidanglefourierfield kernel invocation
var solidanglefourierfield_args solidanglefourierfield_args_t

func init() {
	// CUDA driver kernel call wants pointers to arguments, set them up once.
	solidanglefourierfield_args.argptr[0] = unsafe.Pointer(&solidanglefourierfield_args.arg_fftFx_partial)
	solidanglefourierfield_args.argptr[1] = unsafe.Pointer(&solidanglefourierfield_args.arg_fftFy_partial)
	solidanglefourierfield_args.argptr[2] = unsafe.Pointer(&solidanglefourierfield_args.arg_fftFz_partial)
	solidanglefourierfield_args.argptr[3] = unsafe.Pointer(&solidanglefourierfield_args.arg_fftFx)
	solidanglefourierfield_args.argptr[4] = unsafe.Pointer(&solidanglefourierfield_args.arg_fftFy)
	solidanglefourierfield_args.argptr[5] = unsafe.Pointer(&solidanglefourierfield_args.arg_fftFz)
	solidanglefourierfield_args.argptr[6] = unsafe.Pointer(&solidanglefourierfield_args.arg_Nx)
	solidanglefourierfield_args.argptr[7] = unsafe.Pointer(&solidanglefourierfield_args.arg_Ny)
	solidanglefourierfield_args.argptr[8] = unsafe.Pointer(&solidanglefourierfield_args.arg_Nz)
}

// Wrapper for solidanglefourierfield CUDA kernel, asynchronous.
func k_solidanglefourierfield_async(fftFx_partial unsafe.Pointer, fftFy_partial unsafe.Pointer, fftFz_partial unsafe.Pointer, fftFx unsafe.Pointer, fftFy unsafe.Pointer, fftFz unsafe.Pointer, Nx int, Ny int, Nz int, cfg *config) {
	if Synchronous { // debug
		Sync()
		timer.Start("solidanglefourierfield")
	}

	solidanglefourierfield_args.Lock()
	defer solidanglefourierfield_args.Unlock()

	if solidanglefourierfield_code == 0 {
		solidanglefourierfield_code = fatbinLoad(solidanglefourierfield_map, "solidanglefourierfield")
	}

	solidanglefourierfield_args.arg_fftFx_partial = fftFx_partial
	solidanglefourierfield_args.arg_fftFy_partial = fftFy_partial
	solidanglefourierfield_args.arg_fftFz_partial = fftFz_partial
	solidanglefourierfield_args.arg_fftFx = fftFx
	solidanglefourierfield_args.arg_fftFy = fftFy
	solidanglefourierfield_args.arg_fftFz = fftFz
	solidanglefourierfield_args.arg_Nx = Nx
	solidanglefourierfield_args.arg_Ny = Ny
	solidanglefourierfield_args.arg_Nz = Nz

	args := solidanglefourierfield_args.argptr[:]
	cu.LaunchKernel(solidanglefourierfield_code, cfg.Grid.X, cfg.Grid.Y, cfg.Grid.Z, cfg.Block.X, cfg.Block.Y, cfg.Block.Z, 0, stream0, args)

	if Synchronous { // debug
		Sync()
		timer.Stop("solidanglefourierfield")
	}
}

// maps compute capability on PTX code for solidanglefourierfield kernel.
var solidanglefourierfield_map = map[int]string{0: "",
	50: solidanglefourierfield_ptx_50,
	52: solidanglefourierfield_ptx_52,
	53: solidanglefourierfield_ptx_53,
	60: solidanglefourierfield_ptx_60,
	61: solidanglefourierfield_ptx_61,
	62: solidanglefourierfield_ptx_62,
	70: solidanglefourierfield_ptx_70,
	72: solidanglefourierfield_ptx_72,
	75: solidanglefourierfield_ptx_75,
	80: solidanglefourierfield_ptx_80,
	86: solidanglefourierfield_ptx_86,
	87: solidanglefourierfield_ptx_87,
	89: solidanglefourierfield_ptx_89,
	90: solidanglefourierfield_ptx_90}

// solidanglefourierfield PTX code for various compute capabilities.
const (
	solidanglefourierfield_ptx_50 = `
.version 8.5
.target sm_50
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_52 = `
.version 8.5
.target sm_52
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_53 = `
.version 8.5
.target sm_53
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_60 = `
.version 8.5
.target sm_60
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_61 = `
.version 8.5
.target sm_61
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_62 = `
.version 8.5
.target sm_62
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_70 = `
.version 8.5
.target sm_70
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_72 = `
.version 8.5
.target sm_72
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_75 = `
.version 8.5
.target sm_75
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_80 = `
.version 8.5
.target sm_80
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_86 = `
.version 8.5
.target sm_86
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_87 = `
.version 8.5
.target sm_87
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_89 = `
.version 8.5
.target sm_89
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
	solidanglefourierfield_ptx_90 = `
.version 8.5
.target sm_90
.address_size 64

	// .globl	solidanglefourierfield

.visible .entry solidanglefourierfield(
	.param .u64 solidanglefourierfield_param_0,
	.param .u64 solidanglefourierfield_param_1,
	.param .u64 solidanglefourierfield_param_2,
	.param .u64 solidanglefourierfield_param_3,
	.param .u64 solidanglefourierfield_param_4,
	.param .u64 solidanglefourierfield_param_5,
	.param .u32 solidanglefourierfield_param_6,
	.param .u32 solidanglefourierfield_param_7,
	.param .u32 solidanglefourierfield_param_8
)
{
	.reg .pred 	%p<7>;
	.reg .f32 	%f<16>;
	.reg .b32 	%r<34>;
	.reg .b64 	%rd<25>;


	ld.param.u64 	%rd10, [solidanglefourierfield_param_0];
	ld.param.u64 	%rd11, [solidanglefourierfield_param_1];
	ld.param.u64 	%rd12, [solidanglefourierfield_param_2];
	ld.param.u64 	%rd7, [solidanglefourierfield_param_3];
	ld.param.u64 	%rd8, [solidanglefourierfield_param_4];
	ld.param.u64 	%rd9, [solidanglefourierfield_param_5];
	ld.param.u32 	%r6, [solidanglefourierfield_param_6];
	ld.param.u32 	%r7, [solidanglefourierfield_param_7];
	ld.param.u32 	%r8, [solidanglefourierfield_param_8];
	cvta.to.global.u64 	%rd1, %rd12;
	cvta.to.global.u64 	%rd2, %rd11;
	cvta.to.global.u64 	%rd3, %rd10;
	mov.u32 	%r9, %ntid.x;
	mov.u32 	%r10, %ctaid.x;
	mov.u32 	%r11, %tid.x;
	mad.lo.s32 	%r1, %r10, %r9, %r11;
	mov.u32 	%r12, %ntid.y;
	mov.u32 	%r13, %ctaid.y;
	mov.u32 	%r14, %tid.y;
	mad.lo.s32 	%r2, %r13, %r12, %r14;
	mov.u32 	%r15, %ntid.z;
	mov.u32 	%r16, %ctaid.z;
	mov.u32 	%r17, %tid.z;
	mad.lo.s32 	%r3, %r16, %r15, %r17;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r8;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_4;

	mad.lo.s32 	%r4, %r3, %r7, %r2;
	mad.lo.s32 	%r18, %r4, %r6, %r1;
	shl.b32 	%r19, %r18, 1;
	shr.u32 	%r20, %r6, 31;
	add.s32 	%r21, %r6, %r20;
	shr.s32 	%r22, %r21, 1;
	add.s32 	%r5, %r22, 1;
	setp.gt.s32 	%p6, %r1, %r22;
	cvta.to.global.u64 	%rd13, %rd7;
	mul.wide.s32 	%rd14, %r19, 4;
	add.s64 	%rd4, %rd13, %rd14;
	cvta.to.global.u64 	%rd15, %rd8;
	add.s64 	%rd5, %rd15, %rd14;
	cvta.to.global.u64 	%rd16, %rd9;
	add.s64 	%rd6, %rd16, %rd14;
	@%p6 bra 	$L__BB0_3;
	bra.uni 	$L__BB0_2;

$L__BB0_3:
	sub.s32 	%r25, %r6, %r1;
	rem.s32 	%r26, %r25, %r6;
	sub.s32 	%r27, %r7, %r2;
	rem.s32 	%r28, %r27, %r7;
	sub.s32 	%r29, %r8, %r3;
	rem.s32 	%r30, %r29, %r8;
	mad.lo.s32 	%r31, %r30, %r7, %r28;
	mad.lo.s32 	%r32, %r31, %r5, %r26;
	shl.b32 	%r33, %r32, 1;
	mul.wide.s32 	%rd21, %r33, 4;
	add.s64 	%rd22, %rd3, %rd21;
	ld.global.nc.f32 	%f7, [%rd22];
	st.global.f32 	[%rd4], %f7;
	ld.global.nc.f32 	%f8, [%rd22+4];
	neg.f32 	%f9, %f8;
	st.global.f32 	[%rd4+4], %f9;
	add.s64 	%rd23, %rd2, %rd21;
	ld.global.nc.f32 	%f10, [%rd23];
	st.global.f32 	[%rd5], %f10;
	ld.global.nc.f32 	%f11, [%rd23+4];
	neg.f32 	%f12, %f11;
	st.global.f32 	[%rd5+4], %f12;
	add.s64 	%rd24, %rd1, %rd21;
	ld.global.nc.f32 	%f13, [%rd24];
	st.global.f32 	[%rd6], %f13;
	ld.global.nc.f32 	%f14, [%rd24+4];
	neg.f32 	%f15, %f14;
	st.global.f32 	[%rd6+4], %f15;
	bra.uni 	$L__BB0_4;

$L__BB0_2:
	mad.lo.s32 	%r23, %r4, %r5, %r1;
	shl.b32 	%r24, %r23, 1;
	mul.wide.s32 	%rd17, %r24, 4;
	add.s64 	%rd18, %rd3, %rd17;
	ld.global.nc.f32 	%f1, [%rd18];
	st.global.f32 	[%rd4], %f1;
	ld.global.nc.f32 	%f2, [%rd18+4];
	st.global.f32 	[%rd4+4], %f2;
	add.s64 	%rd19, %rd2, %rd17;
	ld.global.nc.f32 	%f3, [%rd19];
	st.global.f32 	[%rd5], %f3;
	ld.global.nc.f32 	%f4, [%rd19+4];
	st.global.f32 	[%rd5+4], %f4;
	add.s64 	%rd20, %rd1, %rd17;
	ld.global.nc.f32 	%f5, [%rd20];
	st.global.f32 	[%rd6], %f5;
	ld.global.nc.f32 	%f6, [%rd20+4];
	st.global.f32 	[%rd6+4], %f6;

$L__BB0_4:
	ret;

}

`
)
