package cuda

/*
 THIS FILE IS AUTO-GENERATED BY CUDA2GO.
 EDITING IS FUTILE.
*/

import (
	"github.com/mumax/3/cuda/cu"
	"github.com/mumax/3/timer"
	"sync"
	"unsafe"
)

// CUDA handle for scaleemergentfield kernel
var scaleemergentfield_code cu.Function

// Stores the arguments for scaleemergentfield kernel invocation
type scaleemergentfield_args_t struct {
	arg_Fx_scale unsafe.Pointer
	arg_Fy_scale unsafe.Pointer
	arg_Fz_scale unsafe.Pointer
	arg_Fx       unsafe.Pointer
	arg_Fy       unsafe.Pointer
	arg_Fz       unsafe.Pointer
	arg_cx       float32
	arg_cy       float32
	arg_cz       float32
	arg_Nx       int
	arg_Ny       int
	arg_Nz       int
	argptr       [12]unsafe.Pointer
	sync.Mutex
}

// Stores the arguments for scaleemergentfield kernel invocation
var scaleemergentfield_args scaleemergentfield_args_t

func init() {
	// CUDA driver kernel call wants pointers to arguments, set them up once.
	scaleemergentfield_args.argptr[0] = unsafe.Pointer(&scaleemergentfield_args.arg_Fx_scale)
	scaleemergentfield_args.argptr[1] = unsafe.Pointer(&scaleemergentfield_args.arg_Fy_scale)
	scaleemergentfield_args.argptr[2] = unsafe.Pointer(&scaleemergentfield_args.arg_Fz_scale)
	scaleemergentfield_args.argptr[3] = unsafe.Pointer(&scaleemergentfield_args.arg_Fx)
	scaleemergentfield_args.argptr[4] = unsafe.Pointer(&scaleemergentfield_args.arg_Fy)
	scaleemergentfield_args.argptr[5] = unsafe.Pointer(&scaleemergentfield_args.arg_Fz)
	scaleemergentfield_args.argptr[6] = unsafe.Pointer(&scaleemergentfield_args.arg_cx)
	scaleemergentfield_args.argptr[7] = unsafe.Pointer(&scaleemergentfield_args.arg_cy)
	scaleemergentfield_args.argptr[8] = unsafe.Pointer(&scaleemergentfield_args.arg_cz)
	scaleemergentfield_args.argptr[9] = unsafe.Pointer(&scaleemergentfield_args.arg_Nx)
	scaleemergentfield_args.argptr[10] = unsafe.Pointer(&scaleemergentfield_args.arg_Ny)
	scaleemergentfield_args.argptr[11] = unsafe.Pointer(&scaleemergentfield_args.arg_Nz)
}

// Wrapper for scaleemergentfield CUDA kernel, asynchronous.
func k_scaleemergentfield_async(Fx_scale unsafe.Pointer, Fy_scale unsafe.Pointer, Fz_scale unsafe.Pointer, Fx unsafe.Pointer, Fy unsafe.Pointer, Fz unsafe.Pointer, cx float32, cy float32, cz float32, Nx int, Ny int, Nz int, cfg *config) {
	if Synchronous { // debug
		Sync()
		timer.Start("scaleemergentfield")
	}

	scaleemergentfield_args.Lock()
	defer scaleemergentfield_args.Unlock()

	if scaleemergentfield_code == 0 {
		scaleemergentfield_code = fatbinLoad(scaleemergentfield_map, "scaleemergentfield")
	}

	scaleemergentfield_args.arg_Fx_scale = Fx_scale
	scaleemergentfield_args.arg_Fy_scale = Fy_scale
	scaleemergentfield_args.arg_Fz_scale = Fz_scale
	scaleemergentfield_args.arg_Fx = Fx
	scaleemergentfield_args.arg_Fy = Fy
	scaleemergentfield_args.arg_Fz = Fz
	scaleemergentfield_args.arg_cx = cx
	scaleemergentfield_args.arg_cy = cy
	scaleemergentfield_args.arg_cz = cz
	scaleemergentfield_args.arg_Nx = Nx
	scaleemergentfield_args.arg_Ny = Ny
	scaleemergentfield_args.arg_Nz = Nz

	args := scaleemergentfield_args.argptr[:]
	cu.LaunchKernel(scaleemergentfield_code, cfg.Grid.X, cfg.Grid.Y, cfg.Grid.Z, cfg.Block.X, cfg.Block.Y, cfg.Block.Z, 0, stream0, args)

	if Synchronous { // debug
		Sync()
		timer.Stop("scaleemergentfield")
	}
}

// maps compute capability on PTX code for scaleemergentfield kernel.
var scaleemergentfield_map = map[int]string{0: "",
	50: scaleemergentfield_ptx_50,
	52: scaleemergentfield_ptx_52,
	53: scaleemergentfield_ptx_53,
	60: scaleemergentfield_ptx_60,
	61: scaleemergentfield_ptx_61,
	62: scaleemergentfield_ptx_62,
	70: scaleemergentfield_ptx_70,
	72: scaleemergentfield_ptx_72,
	75: scaleemergentfield_ptx_75,
	80: scaleemergentfield_ptx_80,
	86: scaleemergentfield_ptx_86,
	87: scaleemergentfield_ptx_87,
	89: scaleemergentfield_ptx_89,
	90: scaleemergentfield_ptx_90}

// scaleemergentfield PTX code for various compute capabilities.
const (
	scaleemergentfield_ptx_50 = `
.version 8.5
.target sm_50
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_52 = `
.version 8.5
.target sm_52
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_53 = `
.version 8.5
.target sm_53
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_60 = `
.version 8.5
.target sm_60
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_61 = `
.version 8.5
.target sm_61
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_62 = `
.version 8.5
.target sm_62
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_70 = `
.version 8.5
.target sm_70
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_72 = `
.version 8.5
.target sm_72
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_75 = `
.version 8.5
.target sm_75
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_80 = `
.version 8.5
.target sm_80
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_86 = `
.version 8.5
.target sm_86
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_87 = `
.version 8.5
.target sm_87
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_89 = `
.version 8.5
.target sm_89
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
	scaleemergentfield_ptx_90 = `
.version 8.5
.target sm_90
.address_size 64

	// .globl	scaleemergentfield

.visible .entry scaleemergentfield(
	.param .u64 scaleemergentfield_param_0,
	.param .u64 scaleemergentfield_param_1,
	.param .u64 scaleemergentfield_param_2,
	.param .u64 scaleemergentfield_param_3,
	.param .u64 scaleemergentfield_param_4,
	.param .u64 scaleemergentfield_param_5,
	.param .f32 scaleemergentfield_param_6,
	.param .f32 scaleemergentfield_param_7,
	.param .f32 scaleemergentfield_param_8,
	.param .u32 scaleemergentfield_param_9,
	.param .u32 scaleemergentfield_param_10,
	.param .u32 scaleemergentfield_param_11
)
{
	.reg .pred 	%p<6>;
	.reg .f32 	%f<13>;
	.reg .b32 	%r<18>;
	.reg .b64 	%rd<20>;


	ld.param.u64 	%rd1, [scaleemergentfield_param_0];
	ld.param.u64 	%rd2, [scaleemergentfield_param_1];
	ld.param.u64 	%rd3, [scaleemergentfield_param_2];
	ld.param.u64 	%rd4, [scaleemergentfield_param_3];
	ld.param.u64 	%rd5, [scaleemergentfield_param_4];
	ld.param.u64 	%rd6, [scaleemergentfield_param_5];
	ld.param.f32 	%f1, [scaleemergentfield_param_6];
	ld.param.f32 	%f2, [scaleemergentfield_param_7];
	ld.param.f32 	%f3, [scaleemergentfield_param_8];
	ld.param.u32 	%r4, [scaleemergentfield_param_9];
	ld.param.u32 	%r5, [scaleemergentfield_param_10];
	ld.param.u32 	%r6, [scaleemergentfield_param_11];
	mov.u32 	%r7, %ctaid.x;
	mov.u32 	%r8, %ntid.x;
	mov.u32 	%r9, %tid.x;
	mad.lo.s32 	%r1, %r7, %r8, %r9;
	mov.u32 	%r10, %ntid.y;
	mov.u32 	%r11, %ctaid.y;
	mov.u32 	%r12, %tid.y;
	mad.lo.s32 	%r2, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.z;
	mov.u32 	%r14, %ctaid.z;
	mov.u32 	%r15, %tid.z;
	mad.lo.s32 	%r3, %r14, %r13, %r15;
	setp.ge.s32 	%p1, %r1, %r4;
	setp.ge.s32 	%p2, %r2, %r5;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r6;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_2;

	cvta.to.global.u64 	%rd7, %rd4;
	mad.lo.s32 	%r16, %r3, %r5, %r2;
	mad.lo.s32 	%r17, %r16, %r4, %r1;
	mul.wide.s32 	%rd8, %r17, 4;
	add.s64 	%rd9, %rd7, %rd8;
	ld.global.nc.f32 	%f4, [%rd9];
	mul.f32 	%f5, %f4, %f2;
	mul.f32 	%f6, %f5, %f3;
	cvta.to.global.u64 	%rd10, %rd1;
	add.s64 	%rd11, %rd10, %rd8;
	st.global.f32 	[%rd11], %f6;
	cvta.to.global.u64 	%rd12, %rd5;
	add.s64 	%rd13, %rd12, %rd8;
	ld.global.nc.f32 	%f7, [%rd13];
	mul.f32 	%f8, %f7, %f1;
	mul.f32 	%f9, %f8, %f3;
	cvta.to.global.u64 	%rd14, %rd2;
	add.s64 	%rd15, %rd14, %rd8;
	st.global.f32 	[%rd15], %f9;
	cvta.to.global.u64 	%rd16, %rd6;
	add.s64 	%rd17, %rd16, %rd8;
	ld.global.nc.f32 	%f10, [%rd17];
	mul.f32 	%f11, %f10, %f1;
	mul.f32 	%f12, %f11, %f2;
	cvta.to.global.u64 	%rd18, %rd3;
	add.s64 	%rd19, %rd18, %rd8;
	st.global.f32 	[%rd19], %f12;

$L__BB0_2:
	ret;

}

`
)
