package cuda

/*
 THIS FILE IS AUTO-GENERATED BY CUDA2GO.
 EDITING IS FUTILE.
*/

import (
	"github.com/mumax/3/cuda/cu"
	"github.com/mumax/3/timer"
	"sync"
	"unsafe"
)

// CUDA handle for shiftedgecarryX kernel
var shiftedgecarryX_code cu.Function

// Stores the arguments for shiftedgecarryX kernel invocation
type shiftedgecarryX_args_t struct {
	arg_dst         unsafe.Pointer
	arg_src         unsafe.Pointer
	arg_othercomp   unsafe.Pointer
	arg_anothercomp unsafe.Pointer
	arg_Nx          int
	arg_Ny          int
	arg_Nz          int
	arg_shx         int
	arg_clampL      float32
	arg_clampR      float32
	argptr          [10]unsafe.Pointer
	sync.Mutex
}

// Stores the arguments for shiftedgecarryX kernel invocation
var shiftedgecarryX_args shiftedgecarryX_args_t

func init() {
	// CUDA driver kernel call wants pointers to arguments, set them up once.
	shiftedgecarryX_args.argptr[0] = unsafe.Pointer(&shiftedgecarryX_args.arg_dst)
	shiftedgecarryX_args.argptr[1] = unsafe.Pointer(&shiftedgecarryX_args.arg_src)
	shiftedgecarryX_args.argptr[2] = unsafe.Pointer(&shiftedgecarryX_args.arg_othercomp)
	shiftedgecarryX_args.argptr[3] = unsafe.Pointer(&shiftedgecarryX_args.arg_anothercomp)
	shiftedgecarryX_args.argptr[4] = unsafe.Pointer(&shiftedgecarryX_args.arg_Nx)
	shiftedgecarryX_args.argptr[5] = unsafe.Pointer(&shiftedgecarryX_args.arg_Ny)
	shiftedgecarryX_args.argptr[6] = unsafe.Pointer(&shiftedgecarryX_args.arg_Nz)
	shiftedgecarryX_args.argptr[7] = unsafe.Pointer(&shiftedgecarryX_args.arg_shx)
	shiftedgecarryX_args.argptr[8] = unsafe.Pointer(&shiftedgecarryX_args.arg_clampL)
	shiftedgecarryX_args.argptr[9] = unsafe.Pointer(&shiftedgecarryX_args.arg_clampR)
}

// Wrapper for shiftedgecarryX CUDA kernel, asynchronous.
func k_shiftedgecarryX_async(dst unsafe.Pointer, src unsafe.Pointer, othercomp unsafe.Pointer, anothercomp unsafe.Pointer, Nx int, Ny int, Nz int, shx int, clampL float32, clampR float32, cfg *config) {
	if Synchronous { // debug
		Sync()
		timer.Start("shiftedgecarryX")
	}

	shiftedgecarryX_args.Lock()
	defer shiftedgecarryX_args.Unlock()

	if shiftedgecarryX_code == 0 {
		shiftedgecarryX_code = fatbinLoad(shiftedgecarryX_map, "shiftedgecarryX")
	}

	shiftedgecarryX_args.arg_dst = dst
	shiftedgecarryX_args.arg_src = src
	shiftedgecarryX_args.arg_othercomp = othercomp
	shiftedgecarryX_args.arg_anothercomp = anothercomp
	shiftedgecarryX_args.arg_Nx = Nx
	shiftedgecarryX_args.arg_Ny = Ny
	shiftedgecarryX_args.arg_Nz = Nz
	shiftedgecarryX_args.arg_shx = shx
	shiftedgecarryX_args.arg_clampL = clampL
	shiftedgecarryX_args.arg_clampR = clampR

	args := shiftedgecarryX_args.argptr[:]
	cu.LaunchKernel(shiftedgecarryX_code, cfg.Grid.X, cfg.Grid.Y, cfg.Grid.Z, cfg.Block.X, cfg.Block.Y, cfg.Block.Z, 0, stream0, args)

	if Synchronous { // debug
		Sync()
		timer.Stop("shiftedgecarryX")
	}
}

// maps compute capability on PTX code for shiftedgecarryX kernel.
var shiftedgecarryX_map = map[int]string{0: "",
	50: shiftedgecarryX_ptx_50,
	52: shiftedgecarryX_ptx_52,
	53: shiftedgecarryX_ptx_53,
	60: shiftedgecarryX_ptx_60,
	61: shiftedgecarryX_ptx_61,
	62: shiftedgecarryX_ptx_62,
	70: shiftedgecarryX_ptx_70,
	72: shiftedgecarryX_ptx_72,
	75: shiftedgecarryX_ptx_75,
	80: shiftedgecarryX_ptx_80,
	86: shiftedgecarryX_ptx_86,
	87: shiftedgecarryX_ptx_87,
	89: shiftedgecarryX_ptx_89,
	90: shiftedgecarryX_ptx_90}

// shiftedgecarryX PTX code for various compute capabilities.
const (
	shiftedgecarryX_ptx_50 = `
.version 8.5
.target sm_50
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_52 = `
.version 8.5
.target sm_52
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_53 = `
.version 8.5
.target sm_53
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_60 = `
.version 8.5
.target sm_60
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_61 = `
.version 8.5
.target sm_61
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_62 = `
.version 8.5
.target sm_62
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_70 = `
.version 8.5
.target sm_70
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_72 = `
.version 8.5
.target sm_72
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_75 = `
.version 8.5
.target sm_75
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_80 = `
.version 8.5
.target sm_80
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_86 = `
.version 8.5
.target sm_86
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_87 = `
.version 8.5
.target sm_87
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_89 = `
.version 8.5
.target sm_89
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
	shiftedgecarryX_ptx_90 = `
.version 8.5
.target sm_90
.address_size 64

	// .globl	shiftedgecarryX

.visible .entry shiftedgecarryX(
	.param .u64 shiftedgecarryX_param_0,
	.param .u64 shiftedgecarryX_param_1,
	.param .u64 shiftedgecarryX_param_2,
	.param .u64 shiftedgecarryX_param_3,
	.param .u32 shiftedgecarryX_param_4,
	.param .u32 shiftedgecarryX_param_5,
	.param .u32 shiftedgecarryX_param_6,
	.param .u32 shiftedgecarryX_param_7,
	.param .f32 shiftedgecarryX_param_8,
	.param .f32 shiftedgecarryX_param_9
)
{
	.reg .pred 	%p<14>;
	.reg .f32 	%f<14>;
	.reg .b32 	%r<27>;
	.reg .b64 	%rd<27>;


	ld.param.u64 	%rd6, [shiftedgecarryX_param_0];
	ld.param.u64 	%rd7, [shiftedgecarryX_param_1];
	ld.param.u64 	%rd8, [shiftedgecarryX_param_2];
	ld.param.u64 	%rd9, [shiftedgecarryX_param_3];
	ld.param.u32 	%r6, [shiftedgecarryX_param_4];
	ld.param.u32 	%r7, [shiftedgecarryX_param_5];
	ld.param.u32 	%r9, [shiftedgecarryX_param_6];
	ld.param.u32 	%r8, [shiftedgecarryX_param_7];
	ld.param.f32 	%f7, [shiftedgecarryX_param_8];
	ld.param.f32 	%f8, [shiftedgecarryX_param_9];
	cvta.to.global.u64 	%rd1, %rd9;
	cvta.to.global.u64 	%rd2, %rd8;
	cvta.to.global.u64 	%rd3, %rd7;
	mov.u32 	%r10, %ntid.x;
	mov.u32 	%r11, %ctaid.x;
	mov.u32 	%r12, %tid.x;
	mad.lo.s32 	%r1, %r11, %r10, %r12;
	mov.u32 	%r13, %ntid.y;
	mov.u32 	%r14, %ctaid.y;
	mov.u32 	%r15, %tid.y;
	mad.lo.s32 	%r2, %r14, %r13, %r15;
	mov.u32 	%r16, %ntid.z;
	mov.u32 	%r17, %ctaid.z;
	mov.u32 	%r18, %tid.z;
	mad.lo.s32 	%r3, %r17, %r16, %r18;
	setp.ge.s32 	%p1, %r1, %r6;
	setp.ge.s32 	%p2, %r2, %r7;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r9;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_11;

	sub.s32 	%r4, %r1, %r8;
	setp.lt.s32 	%p6, %r4, 0;
	@%p6 bra 	$L__BB0_7;

	setp.lt.s32 	%p7, %r4, %r6;
	mad.lo.s32 	%r19, %r3, %r7, %r2;
	mul.lo.s32 	%r5, %r19, %r6;
	@%p7 bra 	$L__BB0_6;
	bra.uni 	$L__BB0_3;

$L__BB0_6:
	add.s32 	%r22, %r5, %r4;
	mul.wide.s32 	%rd16, %r22, 4;
	add.s64 	%rd17, %rd3, %rd16;
	ld.global.nc.f32 	%f13, [%rd17];
	bra.uni 	$L__BB0_10;

$L__BB0_7:
	mad.lo.s32 	%r23, %r3, %r7, %r2;
	mul.lo.s32 	%r24, %r23, %r6;
	cvt.s64.s32 	%rd5, %r24;
	mul.wide.s32 	%rd18, %r24, 4;
	add.s64 	%rd19, %rd3, %rd18;
	ld.global.nc.f32 	%f13, [%rd19];
	setp.neu.f32 	%p11, %f13, 0f00000000;
	@%p11 bra 	$L__BB0_10;

	shl.b64 	%rd20, %rd5, 2;
	add.s64 	%rd21, %rd2, %rd20;
	ld.global.nc.f32 	%f11, [%rd21];
	setp.neu.f32 	%p12, %f11, 0f00000000;
	@%p12 bra 	$L__BB0_10;

	add.s64 	%rd23, %rd1, %rd20;
	ld.global.nc.f32 	%f12, [%rd23];
	setp.eq.f32 	%p13, %f12, 0f00000000;
	selp.f32 	%f13, %f7, %f13, %p13;
	bra.uni 	$L__BB0_10;

$L__BB0_3:
	add.s32 	%r20, %r6, %r5;
	add.s32 	%r21, %r20, -1;
	cvt.s64.s32 	%rd4, %r21;
	mul.wide.s32 	%rd10, %r21, 4;
	add.s64 	%rd11, %rd3, %rd10;
	ld.global.nc.f32 	%f13, [%rd11];
	setp.neu.f32 	%p8, %f13, 0f00000000;
	@%p8 bra 	$L__BB0_10;

	shl.b64 	%rd12, %rd4, 2;
	add.s64 	%rd13, %rd2, %rd12;
	ld.global.nc.f32 	%f9, [%rd13];
	setp.neu.f32 	%p9, %f9, 0f00000000;
	@%p9 bra 	$L__BB0_10;

	add.s64 	%rd15, %rd1, %rd12;
	ld.global.nc.f32 	%f10, [%rd15];
	setp.eq.f32 	%p10, %f10, 0f00000000;
	selp.f32 	%f13, %f8, %f13, %p10;

$L__BB0_10:
	mad.lo.s32 	%r25, %r3, %r7, %r2;
	mad.lo.s32 	%r26, %r25, %r6, %r1;
	cvta.to.global.u64 	%rd24, %rd6;
	mul.wide.s32 	%rd25, %r26, 4;
	add.s64 	%rd26, %rd24, %rd25;
	st.global.f32 	[%rd26], %f13;

$L__BB0_11:
	ret;

}

`
)
