package cuda

/*
 THIS FILE IS AUTO-GENERATED BY CUDA2GO.
 EDITING IS FUTILE.
*/

import (
	"github.com/mumax/3/cuda/cu"
	"github.com/mumax/3/timer"
	"sync"
	"unsafe"
)

// CUDA handle for setmaxangle kernel
var setmaxangle_code cu.Function

// Stores the arguments for setmaxangle kernel invocation
type setmaxangle_args_t struct {
	arg_dst     unsafe.Pointer
	arg_mx      unsafe.Pointer
	arg_my      unsafe.Pointer
	arg_mz      unsafe.Pointer
	arg_aLUT2d  unsafe.Pointer
	arg_regions unsafe.Pointer
	arg_Nx      int
	arg_Ny      int
	arg_Nz      int
	arg_PBC     byte
	argptr      [10]unsafe.Pointer
	sync.Mutex
}

// Stores the arguments for setmaxangle kernel invocation
var setmaxangle_args setmaxangle_args_t

func init() {
	// CUDA driver kernel call wants pointers to arguments, set them up once.
	setmaxangle_args.argptr[0] = unsafe.Pointer(&setmaxangle_args.arg_dst)
	setmaxangle_args.argptr[1] = unsafe.Pointer(&setmaxangle_args.arg_mx)
	setmaxangle_args.argptr[2] = unsafe.Pointer(&setmaxangle_args.arg_my)
	setmaxangle_args.argptr[3] = unsafe.Pointer(&setmaxangle_args.arg_mz)
	setmaxangle_args.argptr[4] = unsafe.Pointer(&setmaxangle_args.arg_aLUT2d)
	setmaxangle_args.argptr[5] = unsafe.Pointer(&setmaxangle_args.arg_regions)
	setmaxangle_args.argptr[6] = unsafe.Pointer(&setmaxangle_args.arg_Nx)
	setmaxangle_args.argptr[7] = unsafe.Pointer(&setmaxangle_args.arg_Ny)
	setmaxangle_args.argptr[8] = unsafe.Pointer(&setmaxangle_args.arg_Nz)
	setmaxangle_args.argptr[9] = unsafe.Pointer(&setmaxangle_args.arg_PBC)
}

// Wrapper for setmaxangle CUDA kernel, asynchronous.
func k_setmaxangle_async(dst unsafe.Pointer, mx unsafe.Pointer, my unsafe.Pointer, mz unsafe.Pointer, aLUT2d unsafe.Pointer, regions unsafe.Pointer, Nx int, Ny int, Nz int, PBC byte, cfg *config) {
	if Synchronous { // debug
		Sync()
		timer.Start("setmaxangle")
	}

	setmaxangle_args.Lock()
	defer setmaxangle_args.Unlock()

	if setmaxangle_code == 0 {
		setmaxangle_code = fatbinLoad(setmaxangle_map, "setmaxangle")
	}

	setmaxangle_args.arg_dst = dst
	setmaxangle_args.arg_mx = mx
	setmaxangle_args.arg_my = my
	setmaxangle_args.arg_mz = mz
	setmaxangle_args.arg_aLUT2d = aLUT2d
	setmaxangle_args.arg_regions = regions
	setmaxangle_args.arg_Nx = Nx
	setmaxangle_args.arg_Ny = Ny
	setmaxangle_args.arg_Nz = Nz
	setmaxangle_args.arg_PBC = PBC

	args := setmaxangle_args.argptr[:]
	cu.LaunchKernel(setmaxangle_code, cfg.Grid.X, cfg.Grid.Y, cfg.Grid.Z, cfg.Block.X, cfg.Block.Y, cfg.Block.Z, 0, stream0, args)

	if Synchronous { // debug
		Sync()
		timer.Stop("setmaxangle")
	}
}

// maps compute capability on PTX code for setmaxangle kernel.
var setmaxangle_map = map[int]string{0: "",
	50: setmaxangle_ptx_50,
	52: setmaxangle_ptx_52,
	53: setmaxangle_ptx_53,
	60: setmaxangle_ptx_60,
	61: setmaxangle_ptx_61,
	62: setmaxangle_ptx_62,
	70: setmaxangle_ptx_70,
	72: setmaxangle_ptx_72,
	75: setmaxangle_ptx_75,
	80: setmaxangle_ptx_80,
	86: setmaxangle_ptx_86,
	87: setmaxangle_ptx_87,
	89: setmaxangle_ptx_89,
	90: setmaxangle_ptx_90}

// setmaxangle PTX code for various compute capabilities.
const (
	setmaxangle_ptx_50 = `
.version 8.5
.target sm_50
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_52 = `
.version 8.5
.target sm_52
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_53 = `
.version 8.5
.target sm_53
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_60 = `
.version 8.5
.target sm_60
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_61 = `
.version 8.5
.target sm_61
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_62 = `
.version 8.5
.target sm_62
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_70 = `
.version 8.5
.target sm_70
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_72 = `
.version 8.5
.target sm_72
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_75 = `
.version 8.5
.target sm_75
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_80 = `
.version 8.5
.target sm_80
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_86 = `
.version 8.5
.target sm_86
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_87 = `
.version 8.5
.target sm_87
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_89 = `
.version 8.5
.target sm_89
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
	setmaxangle_ptx_90 = `
.version 8.5
.target sm_90
.address_size 64

	// .globl	setmaxangle

.visible .entry setmaxangle(
	.param .u64 setmaxangle_param_0,
	.param .u64 setmaxangle_param_1,
	.param .u64 setmaxangle_param_2,
	.param .u64 setmaxangle_param_3,
	.param .u64 setmaxangle_param_4,
	.param .u64 setmaxangle_param_5,
	.param .u32 setmaxangle_param_6,
	.param .u32 setmaxangle_param_7,
	.param .u32 setmaxangle_param_8,
	.param .u8 setmaxangle_param_9
)
{
	.reg .pred 	%p<44>;
	.reg .b16 	%rs<36>;
	.reg .f32 	%f<318>;
	.reg .b32 	%r<135>;
	.reg .b64 	%rd<69>;


	ld.param.u8 	%rs5, [setmaxangle_param_9];
	ld.param.u64 	%rd7, [setmaxangle_param_0];
	ld.param.u64 	%rd8, [setmaxangle_param_1];
	ld.param.u64 	%rd9, [setmaxangle_param_2];
	ld.param.u64 	%rd10, [setmaxangle_param_3];
	ld.param.u64 	%rd11, [setmaxangle_param_4];
	ld.param.u64 	%rd12, [setmaxangle_param_5];
	ld.param.u32 	%r30, [setmaxangle_param_6];
	ld.param.u32 	%r31, [setmaxangle_param_7];
	ld.param.u32 	%r32, [setmaxangle_param_8];
	cvta.to.global.u64 	%rd1, %rd11;
	cvta.to.global.u64 	%rd2, %rd12;
	cvta.to.global.u64 	%rd3, %rd10;
	cvta.to.global.u64 	%rd4, %rd9;
	cvta.to.global.u64 	%rd5, %rd8;
	mov.u32 	%r33, %ntid.x;
	mov.u32 	%r34, %ctaid.x;
	mov.u32 	%r35, %tid.x;
	mad.lo.s32 	%r1, %r34, %r33, %r35;
	mov.u32 	%r36, %ntid.y;
	mov.u32 	%r37, %ctaid.y;
	mov.u32 	%r38, %tid.y;
	mad.lo.s32 	%r2, %r37, %r36, %r38;
	mov.u32 	%r39, %ntid.z;
	mov.u32 	%r40, %ctaid.z;
	mov.u32 	%r41, %tid.z;
	mad.lo.s32 	%r3, %r40, %r39, %r41;
	setp.ge.s32 	%p1, %r1, %r30;
	setp.ge.s32 	%p2, %r2, %r31;
	or.pred  	%p3, %p1, %p2;
	setp.ge.s32 	%p4, %r3, %r32;
	or.pred  	%p5, %p3, %p4;
	@%p5 bra 	$L__BB0_34;

	mul.lo.s32 	%r4, %r3, %r31;
	add.s32 	%r42, %r4, %r2;
	mul.lo.s32 	%r5, %r42, %r30;
	add.s32 	%r43, %r5, %r1;
	cvt.s64.s32 	%rd6, %r43;
	mul.wide.s32 	%rd13, %r43, 4;
	add.s64 	%rd14, %rd5, %rd13;
	add.s64 	%rd15, %rd4, %rd13;
	add.s64 	%rd16, %rd3, %rd13;
	ld.global.nc.f32 	%f1, [%rd14];
	ld.global.nc.f32 	%f2, [%rd15];
	ld.global.nc.f32 	%f3, [%rd16];
	mul.f32 	%f37, %f2, %f2;
	fma.rn.f32 	%f38, %f1, %f1, %f37;
	fma.rn.f32 	%f39, %f3, %f3, %f38;
	setp.eq.f32 	%p6, %f39, 0f00000000;
	@%p6 bra 	$L__BB0_34;

	add.s64 	%rd17, %rd2, %rd6;
	ld.global.nc.u8 	%rs1, [%rd17];
	and.b16  	%rs2, %rs5, 1;
	setp.eq.s16 	%p7, %rs2, 0;
	add.s32 	%r6, %r1, -1;
	@%p7 bra 	$L__BB0_4;
	bra.uni 	$L__BB0_3;

$L__BB0_4:
	max.s32 	%r129, %r6, 0;
	bra.uni 	$L__BB0_5;

$L__BB0_3:
	rem.s32 	%r44, %r6, %r30;
	add.s32 	%r45, %r44, %r30;
	rem.s32 	%r129, %r45, %r30;

$L__BB0_5:
	add.s32 	%r46, %r129, %r5;
	cvt.s64.s32 	%rd18, %r46;
	mul.wide.s32 	%rd19, %r46, 4;
	add.s64 	%rd20, %rd5, %rd19;
	add.s64 	%rd21, %rd4, %rd19;
	add.s64 	%rd22, %rd3, %rd19;
	ld.global.nc.f32 	%f41, [%rd22];
	ld.global.nc.f32 	%f42, [%rd20];
	ld.global.nc.f32 	%f43, [%rd21];
	mul.f32 	%f44, %f43, %f43;
	fma.rn.f32 	%f45, %f42, %f42, %f44;
	fma.rn.f32 	%f46, %f41, %f41, %f45;
	setp.eq.f32 	%p8, %f46, 0f00000000;
	mov.f32 	%f313, 0f00000000;
	selp.f32 	%f9, %f3, %f41, %p8;
	selp.f32 	%f8, %f2, %f43, %p8;
	selp.f32 	%f7, %f1, %f42, %p8;
	add.s64 	%rd23, %rd2, %rd18;
	ld.global.nc.u8 	%rs6, [%rd23];
	min.u16 	%rs9, %rs6, %rs1;
	max.u16 	%rs10, %rs6, %rs1;
	cvt.u32.u16 	%r47, %rs10;
	add.s32 	%r48, %r47, 1;
	mul.lo.s32 	%r49, %r48, %r47;
	shr.u32 	%r50, %r49, 1;
	cvt.u32.u16 	%r51, %rs9;
	add.s32 	%r52, %r50, %r51;
	mul.wide.s32 	%rd24, %r52, 4;
	add.s64 	%rd25, %rd1, %rd24;
	ld.global.nc.f32 	%f47, [%rd25];
	setp.eq.f32 	%p9, %f47, 0f00000000;
	@%p9 bra 	$L__BB0_7;

	mul.f32 	%f48, %f2, %f8;
	fma.rn.f32 	%f49, %f1, %f7, %f48;
	fma.rn.f32 	%f50, %f3, %f9, %f49;
	abs.f32 	%f51, %f50;
	neg.f32 	%f52, %f51;
	mov.f32 	%f53, 0f3F000000;
	fma.rn.f32 	%f54, %f53, %f52, %f53;
	rsqrt.approx.ftz.f32 	%f55, %f54;
	mul.f32 	%f56, %f54, %f55;
	mul.f32 	%f57, %f55, 0f3F000000;
	neg.f32 	%f58, %f56;
	fma.rn.f32 	%f59, %f58, %f57, %f53;
	fma.rn.f32 	%f60, %f56, %f59, %f56;
	setp.eq.f32 	%p10, %f51, 0f3F800000;
	selp.f32 	%f61, 0f00000000, %f60, %p10;
	mov.f32 	%f62, 0f00000000;
	setp.gt.f32 	%p11, %f51, 0f3F0F5C29;
	selp.f32 	%f63, %f61, %f51, %p11;
	mov.b32 	%r53, %f63;
	mov.b32 	%r54, %f50;
	and.b32  	%r55, %r54, -2147483648;
	or.b32  	%r56, %r55, %r53;
	mov.b32 	%f64, %r56;
	mul.f32 	%f65, %f64, %f64;
	mov.f32 	%f66, 0f3C8B1ABB;
	mov.f32 	%f67, 0f3D10ECEF;
	fma.rn.f32 	%f68, %f67, %f65, %f66;
	mov.f32 	%f69, 0f3CFC028C;
	fma.rn.f32 	%f70, %f68, %f65, %f69;
	mov.f32 	%f71, 0f3D372139;
	fma.rn.f32 	%f72, %f70, %f65, %f71;
	mov.f32 	%f73, 0f3D9993DB;
	fma.rn.f32 	%f74, %f72, %f65, %f73;
	mov.f32 	%f75, 0f3E2AAAC6;
	fma.rn.f32 	%f76, %f74, %f65, %f75;
	mul.f32 	%f77, %f76, %f65;
	fma.rn.f32 	%f78, %f77, %f64, %f64;
	neg.f32 	%f79, %f78;
	selp.f32 	%f80, %f78, %f79, %p11;
	mov.f32 	%f81, 0f3FD774EB;
	mov.f32 	%f82, 0f3F6EE581;
	fma.rn.f32 	%f83, %f82, %f81, %f80;
	setp.gt.f32 	%p12, %f50, 0f3F0F5C29;
	selp.f32 	%f84, %f78, %f83, %p12;
	add.f32 	%f85, %f84, %f84;
	selp.f32 	%f86, %f85, %f84, %p11;
	max.f32 	%f313, %f62, %f86;

$L__BB0_7:
	add.s32 	%r10, %r1, 1;
	@%p7 bra 	$L__BB0_9;
	bra.uni 	$L__BB0_8;

$L__BB0_9:
	add.s32 	%r59, %r30, -1;
	min.s32 	%r130, %r10, %r59;
	bra.uni 	$L__BB0_10;

$L__BB0_8:
	rem.s32 	%r57, %r10, %r30;
	add.s32 	%r58, %r57, %r30;
	rem.s32 	%r130, %r58, %r30;

$L__BB0_10:
	add.s32 	%r60, %r130, %r5;
	cvt.s64.s32 	%rd26, %r60;
	mul.wide.s32 	%rd27, %r60, 4;
	add.s64 	%rd28, %rd5, %rd27;
	add.s64 	%rd29, %rd4, %rd27;
	add.s64 	%rd30, %rd3, %rd27;
	ld.global.nc.f32 	%f87, [%rd30];
	ld.global.nc.f32 	%f88, [%rd28];
	ld.global.nc.f32 	%f89, [%rd29];
	mul.f32 	%f90, %f89, %f89;
	fma.rn.f32 	%f91, %f88, %f88, %f90;
	fma.rn.f32 	%f92, %f87, %f87, %f91;
	setp.eq.f32 	%p14, %f92, 0f00000000;
	selp.f32 	%f14, %f3, %f87, %p14;
	selp.f32 	%f13, %f2, %f89, %p14;
	selp.f32 	%f12, %f1, %f88, %p14;
	add.s64 	%rd31, %rd2, %rd26;
	ld.global.nc.u8 	%rs11, [%rd31];
	min.u16 	%rs14, %rs11, %rs1;
	max.u16 	%rs15, %rs11, %rs1;
	cvt.u32.u16 	%r61, %rs15;
	add.s32 	%r62, %r61, 1;
	mul.lo.s32 	%r63, %r62, %r61;
	shr.u32 	%r64, %r63, 1;
	cvt.u32.u16 	%r65, %rs14;
	add.s32 	%r66, %r64, %r65;
	mul.wide.s32 	%rd32, %r66, 4;
	add.s64 	%rd33, %rd1, %rd32;
	ld.global.nc.f32 	%f93, [%rd33];
	setp.eq.f32 	%p15, %f93, 0f00000000;
	@%p15 bra 	$L__BB0_12;

	mul.f32 	%f94, %f2, %f13;
	fma.rn.f32 	%f95, %f1, %f12, %f94;
	fma.rn.f32 	%f96, %f3, %f14, %f95;
	abs.f32 	%f97, %f96;
	neg.f32 	%f98, %f97;
	mov.f32 	%f99, 0f3F000000;
	fma.rn.f32 	%f100, %f99, %f98, %f99;
	rsqrt.approx.ftz.f32 	%f101, %f100;
	mul.f32 	%f102, %f100, %f101;
	mul.f32 	%f103, %f101, 0f3F000000;
	neg.f32 	%f104, %f102;
	fma.rn.f32 	%f105, %f104, %f103, %f99;
	fma.rn.f32 	%f106, %f102, %f105, %f102;
	setp.eq.f32 	%p16, %f97, 0f3F800000;
	selp.f32 	%f107, 0f00000000, %f106, %p16;
	setp.gt.f32 	%p17, %f97, 0f3F0F5C29;
	selp.f32 	%f108, %f107, %f97, %p17;
	mov.b32 	%r67, %f108;
	mov.b32 	%r68, %f96;
	and.b32  	%r69, %r68, -2147483648;
	or.b32  	%r70, %r69, %r67;
	mov.b32 	%f109, %r70;
	mul.f32 	%f110, %f109, %f109;
	mov.f32 	%f111, 0f3C8B1ABB;
	mov.f32 	%f112, 0f3D10ECEF;
	fma.rn.f32 	%f113, %f112, %f110, %f111;
	mov.f32 	%f114, 0f3CFC028C;
	fma.rn.f32 	%f115, %f113, %f110, %f114;
	mov.f32 	%f116, 0f3D372139;
	fma.rn.f32 	%f117, %f115, %f110, %f116;
	mov.f32 	%f118, 0f3D9993DB;
	fma.rn.f32 	%f119, %f117, %f110, %f118;
	mov.f32 	%f120, 0f3E2AAAC6;
	fma.rn.f32 	%f121, %f119, %f110, %f120;
	mul.f32 	%f122, %f121, %f110;
	fma.rn.f32 	%f123, %f122, %f109, %f109;
	neg.f32 	%f124, %f123;
	selp.f32 	%f125, %f123, %f124, %p17;
	mov.f32 	%f126, 0f3FD774EB;
	mov.f32 	%f127, 0f3F6EE581;
	fma.rn.f32 	%f128, %f127, %f126, %f125;
	setp.gt.f32 	%p18, %f96, 0f3F0F5C29;
	selp.f32 	%f129, %f123, %f128, %p18;
	add.f32 	%f130, %f129, %f129;
	selp.f32 	%f131, %f130, %f129, %p17;
	max.f32 	%f313, %f313, %f131;

$L__BB0_12:
	and.b16  	%rs3, %rs5, 2;
	setp.eq.s16 	%p19, %rs3, 0;
	add.s32 	%r14, %r2, -1;
	@%p19 bra 	$L__BB0_14;
	bra.uni 	$L__BB0_13;

$L__BB0_14:
	max.s32 	%r131, %r14, 0;
	bra.uni 	$L__BB0_15;

$L__BB0_13:
	rem.s32 	%r71, %r14, %r31;
	add.s32 	%r72, %r71, %r31;
	rem.s32 	%r131, %r72, %r31;

$L__BB0_15:
	add.s32 	%r73, %r131, %r4;
	mad.lo.s32 	%r74, %r73, %r30, %r1;
	cvt.s64.s32 	%rd34, %r74;
	mul.wide.s32 	%rd35, %r74, 4;
	add.s64 	%rd36, %rd5, %rd35;
	add.s64 	%rd37, %rd4, %rd35;
	add.s64 	%rd38, %rd3, %rd35;
	ld.global.nc.f32 	%f132, [%rd38];
	ld.global.nc.f32 	%f133, [%rd36];
	ld.global.nc.f32 	%f134, [%rd37];
	mul.f32 	%f135, %f134, %f134;
	fma.rn.f32 	%f136, %f133, %f133, %f135;
	fma.rn.f32 	%f137, %f132, %f132, %f136;
	setp.eq.f32 	%p20, %f137, 0f00000000;
	selp.f32 	%f19, %f3, %f132, %p20;
	selp.f32 	%f18, %f2, %f134, %p20;
	selp.f32 	%f17, %f1, %f133, %p20;
	add.s64 	%rd39, %rd2, %rd34;
	ld.global.nc.u8 	%rs16, [%rd39];
	min.u16 	%rs19, %rs16, %rs1;
	max.u16 	%rs20, %rs16, %rs1;
	cvt.u32.u16 	%r75, %rs20;
	add.s32 	%r76, %r75, 1;
	mul.lo.s32 	%r77, %r76, %r75;
	shr.u32 	%r78, %r77, 1;
	cvt.u32.u16 	%r79, %rs19;
	add.s32 	%r80, %r78, %r79;
	mul.wide.s32 	%rd40, %r80, 4;
	add.s64 	%rd41, %rd1, %rd40;
	ld.global.nc.f32 	%f138, [%rd41];
	setp.eq.f32 	%p21, %f138, 0f00000000;
	@%p21 bra 	$L__BB0_17;

	mul.f32 	%f139, %f2, %f18;
	fma.rn.f32 	%f140, %f1, %f17, %f139;
	fma.rn.f32 	%f141, %f3, %f19, %f140;
	abs.f32 	%f142, %f141;
	neg.f32 	%f143, %f142;
	mov.f32 	%f144, 0f3F000000;
	fma.rn.f32 	%f145, %f144, %f143, %f144;
	rsqrt.approx.ftz.f32 	%f146, %f145;
	mul.f32 	%f147, %f145, %f146;
	mul.f32 	%f148, %f146, 0f3F000000;
	neg.f32 	%f149, %f147;
	fma.rn.f32 	%f150, %f149, %f148, %f144;
	fma.rn.f32 	%f151, %f147, %f150, %f147;
	setp.eq.f32 	%p22, %f142, 0f3F800000;
	selp.f32 	%f152, 0f00000000, %f151, %p22;
	setp.gt.f32 	%p23, %f142, 0f3F0F5C29;
	selp.f32 	%f153, %f152, %f142, %p23;
	mov.b32 	%r81, %f153;
	mov.b32 	%r82, %f141;
	and.b32  	%r83, %r82, -2147483648;
	or.b32  	%r84, %r83, %r81;
	mov.b32 	%f154, %r84;
	mul.f32 	%f155, %f154, %f154;
	mov.f32 	%f156, 0f3C8B1ABB;
	mov.f32 	%f157, 0f3D10ECEF;
	fma.rn.f32 	%f158, %f157, %f155, %f156;
	mov.f32 	%f159, 0f3CFC028C;
	fma.rn.f32 	%f160, %f158, %f155, %f159;
	mov.f32 	%f161, 0f3D372139;
	fma.rn.f32 	%f162, %f160, %f155, %f161;
	mov.f32 	%f163, 0f3D9993DB;
	fma.rn.f32 	%f164, %f162, %f155, %f163;
	mov.f32 	%f165, 0f3E2AAAC6;
	fma.rn.f32 	%f166, %f164, %f155, %f165;
	mul.f32 	%f167, %f166, %f155;
	fma.rn.f32 	%f168, %f167, %f154, %f154;
	neg.f32 	%f169, %f168;
	selp.f32 	%f170, %f168, %f169, %p23;
	mov.f32 	%f171, 0f3FD774EB;
	mov.f32 	%f172, 0f3F6EE581;
	fma.rn.f32 	%f173, %f172, %f171, %f170;
	setp.gt.f32 	%p24, %f141, 0f3F0F5C29;
	selp.f32 	%f174, %f168, %f173, %p24;
	add.f32 	%f175, %f174, %f174;
	selp.f32 	%f176, %f175, %f174, %p23;
	max.f32 	%f313, %f313, %f176;

$L__BB0_17:
	add.s32 	%r18, %r2, 1;
	@%p19 bra 	$L__BB0_19;
	bra.uni 	$L__BB0_18;

$L__BB0_19:
	add.s32 	%r87, %r31, -1;
	min.s32 	%r132, %r18, %r87;
	bra.uni 	$L__BB0_20;

$L__BB0_18:
	rem.s32 	%r85, %r18, %r31;
	add.s32 	%r86, %r85, %r31;
	rem.s32 	%r132, %r86, %r31;

$L__BB0_20:
	add.s32 	%r88, %r132, %r4;
	mad.lo.s32 	%r89, %r88, %r30, %r1;
	cvt.s64.s32 	%rd42, %r89;
	mul.wide.s32 	%rd43, %r89, 4;
	add.s64 	%rd44, %rd5, %rd43;
	add.s64 	%rd45, %rd4, %rd43;
	add.s64 	%rd46, %rd3, %rd43;
	ld.global.nc.f32 	%f177, [%rd46];
	ld.global.nc.f32 	%f178, [%rd44];
	ld.global.nc.f32 	%f179, [%rd45];
	mul.f32 	%f180, %f179, %f179;
	fma.rn.f32 	%f181, %f178, %f178, %f180;
	fma.rn.f32 	%f182, %f177, %f177, %f181;
	setp.eq.f32 	%p26, %f182, 0f00000000;
	selp.f32 	%f24, %f3, %f177, %p26;
	selp.f32 	%f23, %f2, %f179, %p26;
	selp.f32 	%f22, %f1, %f178, %p26;
	add.s64 	%rd47, %rd2, %rd42;
	ld.global.nc.u8 	%rs21, [%rd47];
	min.u16 	%rs24, %rs21, %rs1;
	max.u16 	%rs25, %rs21, %rs1;
	cvt.u32.u16 	%r90, %rs25;
	add.s32 	%r91, %r90, 1;
	mul.lo.s32 	%r92, %r91, %r90;
	shr.u32 	%r93, %r92, 1;
	cvt.u32.u16 	%r94, %rs24;
	add.s32 	%r95, %r93, %r94;
	mul.wide.s32 	%rd48, %r95, 4;
	add.s64 	%rd49, %rd1, %rd48;
	ld.global.nc.f32 	%f183, [%rd49];
	setp.eq.f32 	%p27, %f183, 0f00000000;
	@%p27 bra 	$L__BB0_22;

	mul.f32 	%f184, %f2, %f23;
	fma.rn.f32 	%f185, %f1, %f22, %f184;
	fma.rn.f32 	%f186, %f3, %f24, %f185;
	abs.f32 	%f187, %f186;
	neg.f32 	%f188, %f187;
	mov.f32 	%f189, 0f3F000000;
	fma.rn.f32 	%f190, %f189, %f188, %f189;
	rsqrt.approx.ftz.f32 	%f191, %f190;
	mul.f32 	%f192, %f190, %f191;
	mul.f32 	%f193, %f191, 0f3F000000;
	neg.f32 	%f194, %f192;
	fma.rn.f32 	%f195, %f194, %f193, %f189;
	fma.rn.f32 	%f196, %f192, %f195, %f192;
	setp.eq.f32 	%p28, %f187, 0f3F800000;
	selp.f32 	%f197, 0f00000000, %f196, %p28;
	setp.gt.f32 	%p29, %f187, 0f3F0F5C29;
	selp.f32 	%f198, %f197, %f187, %p29;
	mov.b32 	%r96, %f198;
	mov.b32 	%r97, %f186;
	and.b32  	%r98, %r97, -2147483648;
	or.b32  	%r99, %r98, %r96;
	mov.b32 	%f199, %r99;
	mul.f32 	%f200, %f199, %f199;
	mov.f32 	%f201, 0f3C8B1ABB;
	mov.f32 	%f202, 0f3D10ECEF;
	fma.rn.f32 	%f203, %f202, %f200, %f201;
	mov.f32 	%f204, 0f3CFC028C;
	fma.rn.f32 	%f205, %f203, %f200, %f204;
	mov.f32 	%f206, 0f3D372139;
	fma.rn.f32 	%f207, %f205, %f200, %f206;
	mov.f32 	%f208, 0f3D9993DB;
	fma.rn.f32 	%f209, %f207, %f200, %f208;
	mov.f32 	%f210, 0f3E2AAAC6;
	fma.rn.f32 	%f211, %f209, %f200, %f210;
	mul.f32 	%f212, %f211, %f200;
	fma.rn.f32 	%f213, %f212, %f199, %f199;
	neg.f32 	%f214, %f213;
	selp.f32 	%f215, %f213, %f214, %p29;
	mov.f32 	%f216, 0f3FD774EB;
	mov.f32 	%f217, 0f3F6EE581;
	fma.rn.f32 	%f218, %f217, %f216, %f215;
	setp.gt.f32 	%p30, %f186, 0f3F0F5C29;
	selp.f32 	%f219, %f213, %f218, %p30;
	add.f32 	%f220, %f219, %f219;
	selp.f32 	%f221, %f220, %f219, %p29;
	max.f32 	%f313, %f313, %f221;

$L__BB0_22:
	setp.eq.s32 	%p31, %r32, 1;
	@%p31 bra 	$L__BB0_33;

	and.b16  	%rs4, %rs5, 4;
	setp.eq.s16 	%p32, %rs4, 0;
	add.s32 	%r22, %r3, -1;
	@%p32 bra 	$L__BB0_25;
	bra.uni 	$L__BB0_24;

$L__BB0_25:
	max.s32 	%r133, %r22, 0;
	bra.uni 	$L__BB0_26;

$L__BB0_24:
	rem.s32 	%r100, %r22, %r32;
	add.s32 	%r101, %r100, %r32;
	rem.s32 	%r133, %r101, %r32;

$L__BB0_26:
	mad.lo.s32 	%r102, %r133, %r31, %r2;
	mad.lo.s32 	%r103, %r102, %r30, %r1;
	cvt.s64.s32 	%rd50, %r103;
	mul.wide.s32 	%rd51, %r103, 4;
	add.s64 	%rd52, %rd5, %rd51;
	add.s64 	%rd53, %rd4, %rd51;
	add.s64 	%rd54, %rd3, %rd51;
	ld.global.nc.f32 	%f222, [%rd54];
	ld.global.nc.f32 	%f223, [%rd52];
	ld.global.nc.f32 	%f224, [%rd53];
	mul.f32 	%f225, %f224, %f224;
	fma.rn.f32 	%f226, %f223, %f223, %f225;
	fma.rn.f32 	%f227, %f222, %f222, %f226;
	setp.eq.f32 	%p33, %f227, 0f00000000;
	selp.f32 	%f29, %f3, %f222, %p33;
	selp.f32 	%f28, %f2, %f224, %p33;
	selp.f32 	%f27, %f1, %f223, %p33;
	add.s64 	%rd55, %rd2, %rd50;
	ld.global.nc.u8 	%rs26, [%rd55];
	min.u16 	%rs29, %rs26, %rs1;
	max.u16 	%rs30, %rs26, %rs1;
	cvt.u32.u16 	%r104, %rs30;
	add.s32 	%r105, %r104, 1;
	mul.lo.s32 	%r106, %r105, %r104;
	shr.u32 	%r107, %r106, 1;
	cvt.u32.u16 	%r108, %rs29;
	add.s32 	%r109, %r107, %r108;
	mul.wide.s32 	%rd56, %r109, 4;
	add.s64 	%rd57, %rd1, %rd56;
	ld.global.nc.f32 	%f228, [%rd57];
	setp.eq.f32 	%p34, %f228, 0f00000000;
	@%p34 bra 	$L__BB0_28;

	mul.f32 	%f229, %f2, %f28;
	fma.rn.f32 	%f230, %f1, %f27, %f229;
	fma.rn.f32 	%f231, %f3, %f29, %f230;
	abs.f32 	%f232, %f231;
	neg.f32 	%f233, %f232;
	mov.f32 	%f234, 0f3F000000;
	fma.rn.f32 	%f235, %f234, %f233, %f234;
	rsqrt.approx.ftz.f32 	%f236, %f235;
	mul.f32 	%f237, %f235, %f236;
	mul.f32 	%f238, %f236, 0f3F000000;
	neg.f32 	%f239, %f237;
	fma.rn.f32 	%f240, %f239, %f238, %f234;
	fma.rn.f32 	%f241, %f237, %f240, %f237;
	setp.eq.f32 	%p35, %f232, 0f3F800000;
	selp.f32 	%f242, 0f00000000, %f241, %p35;
	setp.gt.f32 	%p36, %f232, 0f3F0F5C29;
	selp.f32 	%f243, %f242, %f232, %p36;
	mov.b32 	%r110, %f243;
	mov.b32 	%r111, %f231;
	and.b32  	%r112, %r111, -2147483648;
	or.b32  	%r113, %r112, %r110;
	mov.b32 	%f244, %r113;
	mul.f32 	%f245, %f244, %f244;
	mov.f32 	%f246, 0f3C8B1ABB;
	mov.f32 	%f247, 0f3D10ECEF;
	fma.rn.f32 	%f248, %f247, %f245, %f246;
	mov.f32 	%f249, 0f3CFC028C;
	fma.rn.f32 	%f250, %f248, %f245, %f249;
	mov.f32 	%f251, 0f3D372139;
	fma.rn.f32 	%f252, %f250, %f245, %f251;
	mov.f32 	%f253, 0f3D9993DB;
	fma.rn.f32 	%f254, %f252, %f245, %f253;
	mov.f32 	%f255, 0f3E2AAAC6;
	fma.rn.f32 	%f256, %f254, %f245, %f255;
	mul.f32 	%f257, %f256, %f245;
	fma.rn.f32 	%f258, %f257, %f244, %f244;
	neg.f32 	%f259, %f258;
	selp.f32 	%f260, %f258, %f259, %p36;
	mov.f32 	%f261, 0f3FD774EB;
	mov.f32 	%f262, 0f3F6EE581;
	fma.rn.f32 	%f263, %f262, %f261, %f260;
	setp.gt.f32 	%p37, %f231, 0f3F0F5C29;
	selp.f32 	%f264, %f258, %f263, %p37;
	add.f32 	%f265, %f264, %f264;
	selp.f32 	%f266, %f265, %f264, %p36;
	max.f32 	%f313, %f313, %f266;

$L__BB0_28:
	add.s32 	%r26, %r3, 1;
	@%p32 bra 	$L__BB0_30;
	bra.uni 	$L__BB0_29;

$L__BB0_30:
	add.s32 	%r116, %r32, -1;
	min.s32 	%r134, %r26, %r116;
	bra.uni 	$L__BB0_31;

$L__BB0_29:
	rem.s32 	%r114, %r26, %r32;
	add.s32 	%r115, %r114, %r32;
	rem.s32 	%r134, %r115, %r32;

$L__BB0_31:
	mad.lo.s32 	%r117, %r134, %r31, %r2;
	mad.lo.s32 	%r118, %r117, %r30, %r1;
	cvt.s64.s32 	%rd58, %r118;
	mul.wide.s32 	%rd59, %r118, 4;
	add.s64 	%rd60, %rd5, %rd59;
	add.s64 	%rd61, %rd4, %rd59;
	add.s64 	%rd62, %rd3, %rd59;
	ld.global.nc.f32 	%f267, [%rd62];
	ld.global.nc.f32 	%f268, [%rd60];
	ld.global.nc.f32 	%f269, [%rd61];
	mul.f32 	%f270, %f269, %f269;
	fma.rn.f32 	%f271, %f268, %f268, %f270;
	fma.rn.f32 	%f272, %f267, %f267, %f271;
	setp.eq.f32 	%p39, %f272, 0f00000000;
	selp.f32 	%f34, %f3, %f267, %p39;
	selp.f32 	%f33, %f2, %f269, %p39;
	selp.f32 	%f32, %f1, %f268, %p39;
	add.s64 	%rd63, %rd2, %rd58;
	ld.global.nc.u8 	%rs31, [%rd63];
	min.u16 	%rs34, %rs31, %rs1;
	max.u16 	%rs35, %rs31, %rs1;
	cvt.u32.u16 	%r119, %rs35;
	add.s32 	%r120, %r119, 1;
	mul.lo.s32 	%r121, %r120, %r119;
	shr.u32 	%r122, %r121, 1;
	cvt.u32.u16 	%r123, %rs34;
	add.s32 	%r124, %r122, %r123;
	mul.wide.s32 	%rd64, %r124, 4;
	add.s64 	%rd65, %rd1, %rd64;
	ld.global.nc.f32 	%f273, [%rd65];
	setp.eq.f32 	%p40, %f273, 0f00000000;
	@%p40 bra 	$L__BB0_33;

	mul.f32 	%f274, %f2, %f33;
	fma.rn.f32 	%f275, %f1, %f32, %f274;
	fma.rn.f32 	%f276, %f3, %f34, %f275;
	abs.f32 	%f277, %f276;
	neg.f32 	%f278, %f277;
	mov.f32 	%f279, 0f3F000000;
	fma.rn.f32 	%f280, %f279, %f278, %f279;
	rsqrt.approx.ftz.f32 	%f281, %f280;
	mul.f32 	%f282, %f280, %f281;
	mul.f32 	%f283, %f281, 0f3F000000;
	neg.f32 	%f284, %f282;
	fma.rn.f32 	%f285, %f284, %f283, %f279;
	fma.rn.f32 	%f286, %f282, %f285, %f282;
	setp.eq.f32 	%p41, %f277, 0f3F800000;
	selp.f32 	%f287, 0f00000000, %f286, %p41;
	setp.gt.f32 	%p42, %f277, 0f3F0F5C29;
	selp.f32 	%f288, %f287, %f277, %p42;
	mov.b32 	%r125, %f288;
	mov.b32 	%r126, %f276;
	and.b32  	%r127, %r126, -2147483648;
	or.b32  	%r128, %r127, %r125;
	mov.b32 	%f289, %r128;
	mul.f32 	%f290, %f289, %f289;
	mov.f32 	%f291, 0f3C8B1ABB;
	mov.f32 	%f292, 0f3D10ECEF;
	fma.rn.f32 	%f293, %f292, %f290, %f291;
	mov.f32 	%f294, 0f3CFC028C;
	fma.rn.f32 	%f295, %f293, %f290, %f294;
	mov.f32 	%f296, 0f3D372139;
	fma.rn.f32 	%f297, %f295, %f290, %f296;
	mov.f32 	%f298, 0f3D9993DB;
	fma.rn.f32 	%f299, %f297, %f290, %f298;
	mov.f32 	%f300, 0f3E2AAAC6;
	fma.rn.f32 	%f301, %f299, %f290, %f300;
	mul.f32 	%f302, %f301, %f290;
	fma.rn.f32 	%f303, %f302, %f289, %f289;
	neg.f32 	%f304, %f303;
	selp.f32 	%f305, %f303, %f304, %p42;
	mov.f32 	%f306, 0f3FD774EB;
	mov.f32 	%f307, 0f3F6EE581;
	fma.rn.f32 	%f308, %f307, %f306, %f305;
	setp.gt.f32 	%p43, %f276, 0f3F0F5C29;
	selp.f32 	%f309, %f303, %f308, %p43;
	add.f32 	%f310, %f309, %f309;
	selp.f32 	%f311, %f310, %f309, %p42;
	max.f32 	%f313, %f313, %f311;

$L__BB0_33:
	cvta.to.global.u64 	%rd66, %rd7;
	shl.b64 	%rd67, %rd6, 2;
	add.s64 	%rd68, %rd66, %rd67;
	st.global.f32 	[%rd68], %f313;

$L__BB0_34:
	ret;

}

`
)
